<template>
  <div
    v-if="!loader.loading"
    class="overflow-x-hidden h-screen lg:overflow-hidden lg:flex flex-row items-stretch lg:h-full bg-blueGray-200"
  >
    <only-desktop>
      <sidebar v-if="showBar && !isMobile" class="w-1/6 bg-white shadow-lg m-2 rounded-lg" />
    </only-desktop>

    <div :class="{ 'lg:w-5/6': showBar, 'lg:w-full': !showBar }" class="h-full overflow-y-scroll">
      <router-view v-slot="{ Component }">
        <component :is="Component" />
      </router-view>
    </div>

    <only-mobile>
      <navigation-bar
        v-if="showBar && isMobile"
        class="fixed bottom-0 left-0 right-0"
        style="filter: drop-shadow(0 0 3rem rgba(0,0,0,.11))"
      />
    </only-mobile>

    <modal v-for="modal of quickModals" :key="modal.constructor.name" :is="modal" />

    <events-list class="fixed top-0 inset-x-0 m-4 z-10" />
  </div>
  <transition name="fade">
    <div v-if="loader.loadingLong" class="fixed top-0 left-0 w-full h-full z-10">
      <div class="fixed top-0 left-0 w-full h-full bg-white opacity-50" style="z-index: -10"></div>
      <Splashscreen />
    </div>
  </transition>
</template>

<script lang="ts">
import "@/assets/main.css";
import "@/assets/heroicons.css";

import EventsList from "@/components/Events/List.vue";
import Splashscreen from "@/components/Splashscreen.vue";

import { ref, computed, watch, onErrorCaptured } from "vue";
import Workspace from "./models/Workspace";
import router from "@/router";
import Setting from "./models/Setting";
import "./inflector";
import responsive, { isMobile } from "@/use/responsive";
import OnlyDesktop from "./components/OnlyDesktop.vue";
import OnlyMobile from "./components/OnlyMobile.vue";
import Sidebar from "./components/Sidebar.vue";
import NavigationBar from "./components/NavigationBar.vue";
import Views from "./components/Views.vue";
import { QuickModalAction, quickModals } from "@/use/quickModals";
import { Auth } from "@/assets/Auth";
import Task from "./models/Task";
import { DateTime } from "luxon";
import { Loader } from "./use/Loader";

const Transitions = {
  Forward: {
    name: "page-forward",
    mode: undefined
  },
  Backward: {
    name: "page-backward",
    mode: undefined
  },
  Fade: {
    name: "page-fade",
    mode: undefined
  },
  FadeThrough: {
    name: "fade-through",
    mode: "out-in"
  }
};

const baseViews = ["Tasks", "Inbox", "Focus", "Done", "Upcoming"];

const transitions = {};

export default {
  components: { EventsList, Splashscreen, OnlyDesktop, OnlyMobile, Sidebar, Views, NavigationBar },
  setup() {
    onErrorCaptured((...args) => {
      console.log(args);
    });

    const pageTransition = ref<{ name: string; mode?: string }>(Transitions.FadeThrough);

    const boot = () =>
      Auth.ensure()
        .then(async () => {
          // Set up realtime sync
          Workspace.adapter.realtimeSync();
          Task.adapter.realtimeSync();
          // Fetch base state
          await Promise.all([
            Workspace.all().then(workspaces =>
              Promise.all(
                workspaces.map(workspace =>
                  workspace
                    .tasks()
                    .query()
                    .where("doneAt", "!=", null)
                    .first()
                )
              )
            ),
            Setting.all(),
            Task.query()
              .where("doneAt", "==", null)
              .orWhere("doneAt", ">", DateTime.now())
              .get()
          ]);
        })
        .catch(async () => {
          if (await Auth.hasInvalidCredentials()) {
            quickModals.show({
              color: "red",
              title: "Login failed",
              description:
                "Sorry, but your login failed. This could be because your credentials are no longer valid. Please log in again.",
              actions: [QuickModalAction.cancel({ label: "Okay" })]
            });
          }
        });

    const loader = new Loader();

    let inited = false;
    watch(Auth.authKey, () => {
      if (inited) {
        loader.load(boot());
      }
    });
    loader
      .load(Auth.initing)
      .then(() => (inited = true))
      .then(() => loader.load(boot()));

    watch(
      () => [router.currentRoute.value.name, router.currentRoute.value.path.split("/").filter(value => value).length],
      ([toname, todepth], [fromname, fromdepth]) => {
        if (baseViews.includes(fromname) && baseViews.includes(toname)) {
          pageTransition.value = Transitions.FadeThrough;
        } else {
          pageTransition.value =
            transitions[fromname]?.[toname] ||
            (todepth == fromdepth
              ? Transitions.FadeThrough
              : todepth > fromdepth
              ? Transitions.Forward
              : Transitions.Backward);
        }
      }
    );

    return {
      loader,
      responsive,
      pageTransition,
      showBar: computed(() => baseViews.includes(router.currentRoute.value.name)),
      isMobile,
      quickModals
    };
  }
};
</script>
